package com.fufan.mtsaas.modules.sysmgr.sydept.controller;


import com.alibaba.fastjson.JSONObject;
import com.fufan.mtsaas.modules.common.bo.request.DataRequest;
import com.fufan.mtsaas.modules.common.bo.request.ResultPack;
import com.fufan.mtsaas.modules.common.bo.response.RequestPojo;
import com.fufan.mtsaas.modules.common.bo.response.Result;
import com.fufan.mtsaas.modules.sysmgr.sydept.bo.request.DeptVerQueryRequest;
import com.fufan.mtsaas.modules.sysmgr.sydept.bo.request.DeptVerSaveRequest;
import com.fufan.mtsaas.modules.sysmgr.sydept.model.SYDepVer;
import com.fufan.mtsaas.modules.sysmgr.sydept.service.SYDepVerSvc;
import com.fufan.mtsaas.modules.common.bo.request.DataRequest;
import com.fufan.mtsaas.modules.common.bo.request.ResultPack;
import com.fufan.mtsaas.modules.sysmgr.sydept.bo.request.DeptVerQueryRequest;
import com.fufan.mtsaas.modules.sysmgr.sydept.bo.request.DeptVerSaveRequest;
import com.fufan.mtsaas.modules.sysmgr.sydept.model.SYDepVer;
import com.fufan.mtsaas.modules.common.bo.response.RequestPojo;
import com.fufan.mtsaas.modules.common.bo.response.Result;
import com.fufan.mtsaas.modules.sysmgr.sydept.service.SYDepVerSvc;
import com.fufan.mtsaas.util.JSonUtil;
import com.fufan.mtsaas.util.ParamUtil;
import io.swagger.annotations.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpSession;

/**
 * <p>
 * 
 * </p>
 *
 * @author Liby
 * @since 2019-08-19
 */
@Slf4j
@Api(tags = "MTSaas：系统管理-部门版本信息模块", description = "SYDeptVer对象接口")
@RestController
@RequestMapping("/SYS/SYDepVer")
public class SYDepVerCtrl {
    @Autowired
    private SYDepVerSvc targetService;

    /**
     * 分页查询
     * */
    @ApiOperation(value = "分页查询所有，根据需要传入分页参数：pageSize每页数量(默认为10)，currentPage当前页数(默认为1)", httpMethod = "POST", produces = "application/json")

    @PostMapping(value ="/doQueryPage")
    public Result<SYDepVer> doQueryPage(@RequestBody @ApiIgnore DataRequest dataRequest, DeptVerQueryRequest request){
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();
        JSONObject mapdata = dataRequest.getData().getParam();
        DeptVerQueryRequest map = JSonUtil.toBean(mapdata.toJSONString(), DeptVerQueryRequest.class);

        return resultPack.doResultPack(targetService.doQueryPage(map), requestPojo.getIntfId(), requestPojo.getAppKey());
    }

    /**
     * 新增
     * */
    @ApiOperation(value = "新增", httpMethod = "POST", produces = "application/json")
    @RequestMapping(value = "/doSave", method = RequestMethod.POST)
    public Result<SYDepVer> doSaveMap(@RequestBody @ApiIgnore DataRequest dataRequest, DeptVerSaveRequest request, @ApiIgnore HttpSession session){
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();
        JSONObject mapdata = dataRequest.getData().getParam();
        DeptVerSaveRequest map = JSonUtil.toBean(mapdata.toJSONString(), DeptVerSaveRequest.class);

        return resultPack.doResultPack(targetService.doSaveMap(map, requestPojo), requestPojo.getIntfId(), requestPojo.getAppKey());
    }

    /**
     * 修改
     * */
    @ApiOperation(value = "修改", httpMethod = "PUT", produces = "application/json")
    @RequestMapping(value = "/doUpdate", method = RequestMethod.PUT)
    public Result<SYDepVer> doUpdateMap(@RequestBody @ApiIgnore DataRequest dataRequest, DeptVerSaveRequest request, @ApiIgnore HttpSession session){
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();
        JSONObject mapdata = dataRequest.getData().getParam();
        DeptVerSaveRequest map = JSonUtil.toBean(mapdata.toJSONString(), DeptVerSaveRequest.class);

        return resultPack.doResultPack(targetService.doUpdateMap(map, requestPojo), requestPojo.getIntfId(), requestPojo.getAppKey());
    }

    /**
     * 删除数据
     * */
    @ApiOperation(value = "删除数据", httpMethod = "DELETE", produces = "application/json")
    @RequestMapping(value = "/doDelete", method = RequestMethod.DELETE)
    public Result doDelete(@RequestBody @ApiIgnore DataRequest dataRequest, DeptVerQueryRequest request){
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();
        JSONObject mapdata = dataRequest.getData().getParam();
        DeptVerQueryRequest map = JSonUtil.toBean(mapdata.toJSONString(), DeptVerQueryRequest.class);

        return resultPack.doResultPack(targetService.doDelete(map, requestPojo), requestPojo.getIntfId(), requestPojo.getAppKey());
    }
	
}
